<apex:page controller="HCVC_MapController" sidebar="false"  id="myPage">
<html>
<head>
<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?client=gme-huskyoiloperations&v=3.19&sensor=false"></script>
<apex:includeScript value="https://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.9.1.min.js"/>
<style>
/* Control hiding header on screen size */
@media (max-width: 839px) {
  #AppBodyHeader {
    display:none;
  }
}
/* IDs */
#map_canvas { 
    margin: 10px 10px 10px 10px;
    position: relative;
    height: 520px;
    overflow: hidden;
    max-width: 100%;
}
#topoverviewhistoryId,#historyref,#overviewref,#retailnetworkref { display: none; float:none; padding:5px;}


/* Classes */
.hidden {display: none;}
.hn { cursor: pointer; text-decoration: underline;}
.links { cursor:pointer; margin:5px 0px; text-decoration: underline; font-size:18px; }
.MarkerContext{ max-height: 100px; max-width: 200px; }
.MarkerPopUp{ max-height: 100px; max-width: 200px; }
.noscrollbar { line-height:2; overflow:hidden; white-space:nowrap; max-height: 300px; max-width: 400px; }
.sublinks {color:#17A4D1; text-decoration: underline; cursor:pointer;}
.btn-primary-custom:hover {
  background-color: #ffffff;
  color: black;
  border-color: black;
}
.btn-primary-custom {
  color: #fff;
  background-color: #5192bd;
  border-color: black;
}
.custom-button {
  display: inline-block;
  padding: 6px 12px;
  margin-bottom: 5px;
  font-size: 14px;
  font-weight: 400;
  line-height: 1.42857143;
  text-align: center;
  white-space: nowrap;
  vertical-align: middle;
  -ms-touch-action: manipulation;
  touch-action: manipulation;
  cursor: pointer;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  background-image: none;
  border: 1px solid black;
  border-radius: 4px;
}

/* Base Element Tags */
body { font-family:Helvetica Neue,Helvetica,Arial,sans-serif; }
.pbBody span { font-family: Helvetica Neue,Helvetica,Arial,sans-serif !important; font-size: 13px !important; line-height: 1.42857143 !important; }
.pbBody h3 { font-family: Helvetica Neue,Helvetica,Arial,sans-serif !important; font-size: 13px !important; line-height: 1.42857143 !important; }
.pbBody #edn1 { font-family: Helvetica Neue,Helvetica,Arial,sans-serif !important; font-size: 13px !important; line-height: 1.42857143 !important; }
.pbBody strong { font-family: Helvetica Neue,Helvetica,Arial,sans-serif !important; font-size: 13px !important; line-height: 1.42857143 !important; }
tr.ex3:hover { background: #e3f3ff; }
</style>

<script type="text/javascript">
// Declare the map variable
var myMap;

// Define google maps, refinery names and other map coordinates and values
var mapType = google.maps.MapTypeId.SATELLITE;
var refineryname;
var retailSitesFlag = false;
var refineryFlag = true;
var arraddress  = [];
var arrids = [];
var content = [];
var arrnames = [];
var tankCoordinates = [];
var racksCoordinates = [];
var i = 0;

// Variables for tank cooridnates and object
var tankcoordinates=new Object();
var tankpgcoordinates = new Object();
// We store the lat and long of the tanks here
tankpgcoordinates.lats = [];
tankpgcoordinates.longs = [];


// Creating Javascript map object to identify the Assets for the particular Refinery OnClick.
var assetUnitsMap=new Object();

// Javascript object for asset units containing lat, long, and other details about the asset
var assetUnits=new Object();
assetUnits.lats = [];
assetUnits.longs = [];
assetUnits.details = [];
assetUnits.assettypes = [];
assetUnits.assetids = [];
assetUnits.tanknos = [];
assetUnits.substances = [];
assetUnits.names = [];
assetUnits.parentname = [];

var tempassetId = '';
var d = 0;

// Loop through the assetUnits list with apex
<apex:repeat value="{!assetUnits}" var="au" >
  // Increase the iterator each time starting at 1
  d++;
  // If there is no ID we are at parent
  if(tempassetId == '') {
    tempassetId = '{!au.Parent_Refinery_Asset__r.Id}';

    assetUnits.lats.push("{!au.Lat__c}");
    assetUnits.longs.push("{!au.Long__c}");
    assetUnits.details.push("{!au.Details__c}");
    assetUnits.assettypes.push("{!au.RecordTypeId}");
    assetUnits.assetids.push("{!au.Id}");
    //assetUnits.tanknos.push("{!au.Tank_Number__c}");
    assetUnits.substances.push("{!au.Substance__c}");
    assetUnits.names.push("{!au.Name}");
    assetUnits.parentname.push("{!au.Parent_Refinery_Asset__r.Name}");
    // We are not at parent, at a sub asset
  } else if(tempassetId != "{!au.Parent_Refinery_Asset__r.Id}") {

    assetUnitsMap[tempassetId]=assetUnits;
    assetUnits=new Object();
    assetUnits.lats = [];
    assetUnits.longs = [];
    assetUnits.details = [];
    assetUnits.assettypes = [];
    assetUnits.assetids = [];
    assetUnits.tanknos = [];
    assetUnits.substances = [];
    assetUnits.names = [];
    assetUnits.parentname = [];

    assetUnits.lats.push("{!au.Lat__c}");
    assetUnits.longs.push("{!au.Long__c}");
    assetUnits.details.push("{!au.Details__c}");
    assetUnits.assettypes.push("{!au.RecordTypeId}");
    assetUnits.assetids.push("{!au.Id}");
    assetUnits.tanknos.push("{!au.Tank_Number__c}");
    assetUnits.substances.push("{!au.Substance__c}");
    assetUnits.names.push("{!au.Name}");
    assetUnits.parentname.push("{!au.Parent_Refinery_Asset__r.Name}");
    // Store in the asset map
  } else if(tempassetId == "{!au.Parent_Refinery_Asset__r.Id}") {

    assetUnits.lats.push("{!au.Lat__c}");
    assetUnits.longs.push("{!au.Long__c}");
    assetUnits.details.push("{!au.Details__c}");
    assetUnits.assettypes.push("{!au.RecordTypeId}");
    assetUnits.assetids.push("{!au.Id}");
    assetUnits.tanknos.push("{!au.Tank_Number__c}");
    assetUnits.substances.push("{!au.Substance__c}");
    assetUnits.names.push("{!au.Name}");
    assetUnits.parentname.push("{!au.Parent_Refinery_Asset__r.Name}");
    if("{!assetUnits.size}" == d){
      assetUnitsMap[tempassetId]=assetUnits;
    }
  }

  // Set the ID to the parent refinery ID
  tempassetId="{!au.Parent_Refinery_Asset__r.Id}";
</apex:repeat>

// Add in the tank coordinates from the tank object
<apex:repeat value="{!tankPGCoordinates}" var="tc">
  tankpgcoordinates.lats.push("{!tc.Lat__c}");
  tankpgcoordinates.longs.push("{!tc.Long__c}");
</apex:repeat>

// We only set up the tank coordinates for prince george here
tankcoordinates['Prince_George_Refinery'] = tankpgcoordinates;

// Define the object for the rack coordinates for the PG Refinery only
var rackscoordinates=new Object();
var rackspgcoordinates= new Object();
rackspgcoordinates.lats = [];
rackspgcoordinates.longs = [];

<apex:repeat value="{!racksPGCoordinates}" var="rpc">
  rackspgcoordinates.lats.push("{!rpc.Lat__c}");
  rackspgcoordinates.longs.push("{!rpc.Long__c}");
</apex:repeat>

// Add the rack coordinates for PG
rackscoordinates['Prince_George_Refinery']=rackspgcoordinates;

// Put all the pipeline values into the following objects to make it dynamic
// and have the ability to search based on property name
var srcpipeline = [];
<apex:repeat value="{!crudepipline}" var="jsonName">
srcpipeline.push("{!jsonName}");
</apex:repeat>
var srcpipelineName = [];
<apex:repeat value="{!crudepiplineName}" var="resourceName">
srcpipelineName.push("{!resourceName}");
</apex:repeat>
var srcpipelineId = [];
<apex:repeat value="{!crudepiplineId}" var="id">
srcpipelineId.push("{!id}");
</apex:repeat>

// Define lat, long and other details for asset
var lats = [];
var longs = [];
var details = [];
var assettypes = [];
var assetids = [];
var assestnames = [];
var tanknos = [];
var substances = [];

// Set up geojson object
var geoJsonNames=new Object();
geoJsonNames.resourceName = [];
geoJsonNames.jsonName = [];

// Define current refinery for use in loading refinery details
var currentRefinery = null;

// Define lat long, type, details id and name for refinery
var refineryLat;
var refineryLong;
var refineryType;
var refineryDeatils;
var refineryId;
var refineryname;

// Refinery Global Object for Refinery Checkbox
var Refineryobj = new Object();
Refineryobj.type='Refinery';
Refineryobj.lats = [];
Refineryobj.longs = [];
Refineryobj.details = [];
Refineryobj.assettypes = [];
Refineryobj.assetids = [];
Refineryobj.assestnames = [];
Refineryobj.flag = true;

// Pipeline Global Object for Pipeline Checkbox
var Pipelineobj = new Object();
Pipelineobj.type = 'Pipeline';
Pipelineobj.geoJsonName = [];
Pipelineobj.resourceName = [];
Pipelineobj.flag = false;

// Transport global object for Transport layer
var TransportLayerobj = new Object();
TransportLayerobj.type = 'TransportLayer';
TransportLayerobj.geoJsonName = [];
TransportLayerobj.resourceName = [];
TransportLayerobj.name = [];
TransportLayerobj.geoType = [];
TransportLayerobj.flag = false;


// etail Global Object for Retail Checkbox
var Retailobj = new Object();
Retailobj.type='Retail';
Retailobj.lats = [];
Retailobj.longs = [];
Retailobj.details = [];
Retailobj.assettypes = [];
Retailobj.assetids = [];
Retailobj.assestnames = [];
Retailobj.flag=false;

// Here we get the asset details for each asset
<apex:repeat value="{!assets}" var="a">

  // If the asset type is refinery, push in the details to the 
  // refinery object for the top level refinery as well as the asset names
  // for that refinery, used in detail overviews.
  if("{!a.RecordTypeId}" == "{!refineryTypeId}") {
    refineryLat = "{!a.Lat__c}";
    refineryLong = "{!a.Long__c}";
    refineryType = "{!a.RecordTypeId}";
    refineryDeatils = "{!a.Details__c}";
    refineryId = "{!a.Id}";
    refineryname = "{!a.Name}";

    Refineryobj.lats.push("{!a.Lat__c}");
    Refineryobj.longs.push("{!a.Long__c}");
    Refineryobj.details.push("{!a.Details__c}");
    Refineryobj.assettypes.push("{!a.RecordTypeId}");
    Refineryobj.assetids.push("{!a.Id}");
    Refineryobj.assestnames.push("{!a.Name}");
  }

  // Push the asset details into the lists that are below the refinery object
  lats.push("{!a.Lat__c}");
  longs.push("{!a.Long__c}");
  details.push("{!a.Details__c}");
  assettypes.push("{!a.RecordTypeId}");
  assetids.push("{!a.Id}");
  assestnames.push("{!a.Name}");

</apex:repeat>


// Load in the details for the retail Object locations
<apex:repeat value="{!retailLocations}" var="rl">

  Retailobj.lats.push("{!rl.Latitude__c}");
  Retailobj.longs.push("{!rl.Longitude__c}");  
  Retailobj.details.push("{!rl.Location_Name__c}");
  Retailobj.assettypes.push('Retail');
  Retailobj.assetids.push("{!rl.Id}");
  Retailobj.assestnames.push("{!HTMLENCODE(rl.Name)}");

</apex:repeat>

// Load in the pipeline names and resource names
<apex:repeat value="{!pipelineResourceNames}" var="resourceName">
   Pipelineobj.resourceName.push('{!resourceName}');
</apex:repeat>
<apex:repeat value="{!pipelineJsonNames}" var="jsonName">
   Pipelineobj.geoJsonName.push('{!jsonName}');
</apex:repeat>

// Load in all the geojson, differntiate type later
// Also store values permantly for use in click handler
var geoJsonNamePerm = [];
var namePerm = [];
var resourceNamePerm = [];
var geoTypePerm = [];

<apex:repeat value="{!geoJson}" var="geo">
  TransportLayerobj.geoJsonName.push('{!geo}');
</apex:repeat>
<apex:repeat value="{!geoJsonName}" var="geoName">
   TransportLayerobj.name.push('{!geoName}');
</apex:repeat>
<apex:repeat value="{!geoJsonResourceName}" var="geoResource">
   TransportLayerobj.resourceName.push('{!geoResource}');
</apex:repeat>
<apex:repeat value="{!geoJsonType}" var="geoType">
   TransportLayerobj.geoType.push('{!geoType}');
</apex:repeat>
// Set the values forever
geoJsonNamePerm = TransportLayerobj.geoJsonName;
namePerm = TransportLayerobj.name;
resourceNamePerm = TransportLayerobj.resourceName;
geoTypePerm = TransportLayerobj.geoType;

// Here we set up the default paths for google maps
function preSetup() {

  // If we are on a refinery layer and not top level view, do the following
  if('{!backmapFlag}'=='true') {
    mapType = google.maps.MapTypeId.HYBRID;
    refineryPathName = '{!assets[0].Parent_Refinery_Asset__r.Name}';
    // Set the current refinery name for use in loading geojson for refinery borders
    currentRefinery = refineryPathName;
    refineryPathName = refineryPathName.replace(/ /g,"_");

	// Here we load the tank coordinates and the racks coordinates for PG refinery
    if('{!backmaptankCoordinates.size}'>0){
      <apex:repeat value="{!backmaptankCoordinates}" var="tc">
        tankCoordinates.push(new google.maps.LatLng('{!tc.latitude}','{!tc.longitude}'));
      </apex:repeat>
    }

    <apex:repeat value="{!racksPGCoordinates}" var="rpc">
      racksCoordinates.push(new google.maps.LatLng('{!rpc.Lat__c}','{!rpc.Long__c}'));
    </apex:repeat>

    <apex:repeat value="{!parentRefineries}" var="pf">
      Refineryobj.lats.push("{!pf.Lat__c}");
      Refineryobj.longs.push("{!pf.Long__c}");
      Refineryobj.details.push("{!pf.Details__c}");
      Refineryobj.assettypes.push("{!pf.RecordTypeId}");
      Refineryobj.assetids.push("{!pf.Id}");
      Refineryobj.assestnames.push("{!pf.Name}");
    </apex:repeat>
  } else {
    if('{!backtoMapExt}' == 'true') {
      if('{!isRefinery}' == 'true') {
        document.getElementById('myPage:formid:pbid:pbsid:Refinery').checked = true;
        Refineryobj.flag = true;
      } else {
        Refineryobj.flag = false;
        document.getElementById('myPage:formid:pbid:pbsid:Refinery').checked = false;
      }
      if('{!isPipeline}' == 'true') {
        document.getElementById('myPage:formid:pbid:pbsid:pipeline').checked = true;
        Pipelineobj.flag = true;
      }
      if('{!isRetail}' == 'true') {
        document.getElementById('myPage:formid:pbid:pbsid:RetailSite').checked = true;
        Retailobj.flag = true;
      }
      if('{!isTransport}' == 'true') {
        document.getElementById('myPage:formid:pbid:pbsid:transportlayer').checked = true;
        TransportLayerobj.flag = true;
      }
      BackToMapStatus();
    }
    mapType = google.maps.MapTypeId.ROADMAP;
  }
  // Call the initialize function for the map after setup complete
  initialize();
}

// Javascript method to load the KMZ layer on the map
function loadKmlLayer(url,myMap){
  var kmlLayer;
  // Create a new KML Layer based on URL passed in, do not zoom in if it is a pipeline or a railway
  if(srcpipeline.indexOf(url) > -1 || (geoJsonNamePerm.indexOf(url) > -1 && geoTypePerm[geoJsonNamePerm.indexOf(url)] == "Railway")) {
	  kmlLayer = new google.maps.KmlLayer({
	    url: url,
	    suppressInfoWindows: true,
	    map: myMap,
	    preserveViewport:true
	  });
  } else {
   	 kmlLayer = new google.maps.KmlLayer({
	    url: url,
	    suppressInfoWindows: true,
	    map: myMap
	 });
  }

  var infoWindow = new google.maps.InfoWindow();

  // Add listeners for various content based on what type of layer it is
  google.maps.event.addListener(kmlLayer, 'click', function(kmlMouseEvent) {
  	 // Now we do a lookup based on the name to get the ID and name associated with this property name
    if(srcpipeline.indexOf(url) > -1){
      // Now we set the pipeline content and position and bind it to open on the map when clicked
      var infoWindow = new google.maps.InfoWindow();
      var pipelineContent = '<a href={!basePathSFDC}/apex/HCVC_AssetDetails?id=' + srcpipelineId[srcpipeline.indexOf(url)] + '><div class="noscrollbar">' + srcpipelineName[srcpipeline.indexOf(url)] + '</div></a>';
      infoWindow.setContent(pipelineContent);
      infoWindow.setPosition(kmlMouseEvent.latLng);
      infoWindow.open(myMap);
    }

    if(geoJsonNamePerm.indexOf(url) > -1 && geoTypePerm[geoJsonNamePerm.indexOf(url)] == "Railway") {
      // Here we set the popup for railways, we dont worry about refinerys
      var infoWindow = new google.maps.InfoWindow();
      var railwayName=namePerm[geoJsonNamePerm.indexOf(url)];
      infoWindow.setContent('<div class="noscrollbar">'+railwayName+'</div>');
      infoWindow.setPosition(kmlMouseEvent.latLng);
      infoWindow.open(myMap);
    }
  });
}

// Loads the geojson on the map 
function loadGeoLayer(resourceName, jsonName, myMap) {
  var ranOnce = false;
  // Loop through all pipeline resources with geojson and add them in to the map by default if in the kml paths object
  <apex:repeat value="{!pipelineResourceNames}" var="pipeline" >
    // We only load the geojson data if the resource name matches. This is a hack to dyanmically assign it. 
    // The jsonName can be dynamically assigned from javascript though
    if("{!pipeline}" == resourceName) {
      <apex:repeat value="{!pipelineJsonNames}" var="pipelineName" >
	      if("{!pipelineName}" == jsonName) {
	      	myMap.data.loadGeoJson("{!URLFOR($Resource[pipeline],pipelineName)}");
	      }
	  </apex:repeat>
    }
  </apex:repeat>
  <apex:repeat value="{!geoJsonResourceName}" var="resource" >
    // Only run once for cases when the resource name is the same for multiple json files
    if(!ranOnce) {
	    // We only load the geojson data if the resource name matches. This is a hack to dyanmically assign it. 
	    // The jsonName can be dynamically assigned from javascript though
	    if("{!resource}" == resourceName) {
	      <apex:repeat value="{!geoJson}" var="geoName" >
		      if("{!geoName}" == jsonName) {
		      	myMap.data.loadGeoJson("{!URLFOR($Resource[resource],geoName)}");
		      }
	      </apex:repeat>
	      // Set the colors depending on the propertys
		  myMap.data.setStyle(function(feature) {
		    // Default color is black
		    var color = 'black';
		    var fillOpacity = '0.0';
		    // If the property exists, set the color
		    if (feature.getProperty('lineColor')) {
		      color = feature.getProperty('lineColor');
		    }
		    return /** @type {google.maps.Data.StyleOptions} */({
		      strokeColor: color,
		      fillOpacity: fillOpacity
		    });
		  });
		  
		  // Load the bound settings only if we are not on top level view
		  if(currentRefinery != null) {
		  $.getJSON('{!URLFOR($Resource[resource], "' + jsonName + '")}')
		    .done(function (data) {
		    	var bounds = new google.maps.LatLngBounds();
		    	var a, b, point = null;
				var tempArray = data.features[0].geometry.coordinates[0];
				for (var ii = 0; ii < data.features[0].geometry.coordinates[0].length; ii++) {
					var arrayAtCoord = tempArray[ii];
				    a = arrayAtCoord[1];
					b = arrayAtCoord[0];
					point = new google.maps.LatLng(a, b);
					bounds.extend(point);
				}
				myMap.fitBounds(bounds);
		  	});
		  }
		  ranOnce = true;
	    }
    }
  </apex:repeat>

}

function initGeoClickListener(myMap) {
  // This adds a click listener for all geojson objects that have clickable functionality
  myMap.data.addListener('click', function(event) {
      // On click for geojson, we first get the property name attribute for the layer that was clicked
      var propertyName = event.feature.getProperty("name");
      
      // Make sure the property name exists, then continue with lookup and ID association
      if(propertyName != undefined) {
        // Now we do a lookup based on the name to get the ID and name associated with this property name
        if(srcpipeline.indexOf(propertyName) > -1){
          // Now we set the pipeline content and position and bind it to open on the map when clicked
          var infoWindow = new google.maps.InfoWindow();
          var pipelineContent = '<a href={!basePathSFDC}/apex/HCVC_AssetDetails?id=' + srcpipelineId[srcpipeline.indexOf(propertyName)] + '><div class="noscrollbar">' + srcpipelineName[srcpipeline.indexOf(propertyName)] + '</div></a>';
          infoWindow.setContent(pipelineContent);
          infoWindow.setPosition(event.latLng);
          infoWindow.open(myMap);
        }

        if(geoJsonNamePerm.indexOf(propertyName) > -1 && geoTypePerm[geoJsonNamePerm.indexOf(propertyName)] == "Railway") {
          // Here we set the popup for railways, we dont worry about refinerys
          var infoWindow = new google.maps.InfoWindow();
          var railwayName=namePerm[geoJsonNamePerm.indexOf(propertyName)];
          infoWindow.setContent('<div class="noscrollbar">'+railwayName+'</div>');
          infoWindow.setPosition(event.latLng);
          infoWindow.open(myMap);
        }
      }
  });
}

// Javascript method to Initialise the Map and load the KMZ paths,Placemarkers.
// This sets up the google maps and binds it to the map canvas
// Sets up everything we need for the google map displayed on the page
function initialize() {

  var myLatlng; // Lat and Long variable

  var mapDiv = document.getElementById('map-canvas'); // Map div

  // ROADMAP can be changed to SATELLITE, TERRAIN, and HYBRID
  var myOptions = {
    mapTypeId: mapType,
    zoom: 4,
    center: {lat: 53.9793, lng: -122.7008}
  }

 // Bind the map to the map canvas and create the google map
  myMap = new google.maps.Map(document.getElementById("map_canvas"), myOptions);

	// Tells us when the map is done loading
    google.maps.event.addListenerOnce(myMap, 'idle', function() {
		console.log('Loaded base map');
	});  
  // Set the map zoom based on map type 
  if( myMap.getMapTypeId() === google.maps.MapTypeId.HYBRID ) {
    myMap.setOptions({maxZoom:21});
  } else if( myMap.getMapTypeId() === google.maps.MapTypeId.ROADMAP ) {
    myMap.setOptions({maxZoom:4});
  }

  // Loop through the geojson obj and print out the names
  for(var a=0;a<geoJsonNames.resourceName.length;a++){
    loadKmlLayer(geoJsonNames.jsonName[a], myMap);
  }
  // Loop through the geojson railway and load them when the railway flag is true, other geojson such as refinerys are loaded when markers are clicked
  for(var a=0;a<TransportLayerobj.geoJsonName.length;a++) {
      // Only load the railway if the flag is true
      if(TransportLayerobj.geoType[a] == "Railway" && TransportLayerobj.flag == true) {
        loadKmlLayer(TransportLayerobj.geoJsonName[a], myMap);
      }
  }
  
  // Load the geojson for the current refinery if it is set
  if(currentRefinery != null) {  
    // Here we want to load the geojson data for the refinery clicked
	if(namePerm.indexOf(currentRefinery) > -1) {
		var refineryIndex = namePerm.indexOf(currentRefinery);
		loadKmlLayer(geoJsonNamePerm[refineryIndex], myMap); 
	}
  }

  // Setup the click listener for the geojson stuff once
  initGeoClickListener(myMap);


  // infowindow for Prince George Tank
  var infopolygon = new google.maps.InfoWindow();

  // infowindow for Prince George Rack
  var infopolygonrack = new google.maps.InfoWindow();
  

  // Set up array of markers
  markers  = [];
  for (var i = 0; i < lats.length; i++) {
    myLatlng = new google.maps.LatLng(parseFloat(lats[i]),parseFloat(longs[i]));

    circlemyLatlng = new google.maps.LatLng(53.9793,-122.7008);

    var contentString;
    if(assettypes[i]=='{!tankTypeId}') {
      contentString = '<div class="noscrollbar"><b>Tank Number : </b>'+tanknos[i]+'<br/><b>Substance : </b>'+substances[i]+'</div>';
    } else if(assettypes[i]=='Retail') {
      contentString = '<div class="noscrollbar"><b>Site : </b>'+assestnames[i]+'<br/><b>Location Name : </b>'+details[i]+'</div>';
    }
    else {
       contentString =assestnames[i];
    }
    var infowindow = new google.maps.InfoWindow({
       content: contentString
    });

    var marker = new google.maps.Marker({
        position: myLatlng,
        map: myMap,
        //this creates a new html string for each
        html: contentString,
        assettype:assettypes[i],
        assetId:assetids[i]
    });

    // This draws crude pipleline markers only for prince george Hardcoded in
    if(document.getElementById('myPage:formid:pbid:pbsid:pipeline').checked == true){
      // -------------- MARKER 1   55.877356,-120.614036   //
      var marker1 = new google.maps.Marker({
        position: new google.maps.LatLng('{!TaylorLat}', '{!TaylorLong}'),
        map: myMap,
        icon: "{!URLFOR($Resource.HCVC_Portal,'image/blue-dot.png')}"
      });

      var infowindow1 = new google.maps.InfoWindow({
       content: '<div class="noscrollbar">'+"Taylor Terminal"+'</div>'
      });

      google.maps.event.addListener(marker1, 'mouseover', function() {
        infowindow1.open(myMap, marker1);
      });

      google.maps.event.addListener(marker1, 'mouseout', function() {
       infowindow1.close();
      });

      // -------- END OF 1st MARKER

      // -------------- MARKER 2  50.620683,-120.328147 //
      var marker2 = new google.maps.Marker({
        position: new google.maps.LatLng('{!KamloopsLat}', '{!KamloopsLong}'),
        map: myMap,
        icon: "{!URLFOR($Resource.HCVC_Portal,'image/blue-dot.png')}"
      });

      var infowindow2 = new google.maps.InfoWindow({
        content: '<div class="noscrollbar">'+"Kamloops Terminal"+'</div>'
      });

      google.maps.event.addListener(marker2, 'mouseover', function() {
        infowindow2.open(myMap, marker2);
      });

      google.maps.event.addListener(marker2, 'mouseout', function() {
        infowindow2.close();
      });
      // -------- END OF 2nd MARKER
    }

    // Icon type set to green for retail
    if(assettypes[i]=='Retail'){
      marker.setIcon("{!URLFOR($Resource.HCVC_Portal,'image/green-dot.png')}");
    }

    // Icon type set to blue for refinery unit
    if(assettypes[i]=='{!refineryUnitTypeId}'){
      // Hide the filters on refinery unit pages
      var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
      search.style.display = 'none';
      marker.setIcon("{!URLFOR($Resource.HCVC_Portal,'image/blue-dot.png')}");
    }

    // This is for the tank polygon coordinates
    var tankpolygon = [];
    if(tankCoordinates.length>0) {
        // Construct the polygon.
       tankpolygon = new google.maps.Polygon({
        paths: tankCoordinates,
        strokeColor: '#0099FF',
        strokeOpacity: 0.0,
        strokeWeight: 3,
         fillColor: '#0099FF',
         fillOpacity:0.025,
         zIndex: 999999,
         refineryName:refineryname,
         assetId:assetids[i]
      });
      tankpolygon.setMap(myMap);
    }

    // This is for the racks polygon coordinates
    var rackspolygon = [];
    if(racksCoordinates.length>0){
        // Construct the polygon.
       rackspolygon = new google.maps.Polygon({
        paths: racksCoordinates,
        strokeColor: '#FF7F00',
        strokeOpacity: 0.0,
        strokeWeight: 3,
         fillColor: '#FF7F00',
         fillOpacity:0.075,
         zIndex: 999999,
         refineryName:refineryname,
         assetId:assetids[i]
      });
      rackspolygon.setMap(myMap);
    }

    var assettype = assettypes[i];
    var assetId = assetids[i];

    // Add a listener for the click event on the tanks and redirect
    google.maps.event.addListener(tankpolygon, 'click', function(){
      window.location.href ='{!basePathSFDC}/apex/HCVC_TankMapPage?id='+this.assetId;
    });

    // Add a listener for the Racks click event on the racks and redirect
    google.maps.event.addListener(rackspolygon, 'click', function(){
      window.location.href ='{!basePathSFDC}/apex/HCVC_RacksDetails?id='+this.assetId+'&aflag=false';
    });

    // Add listeners for clicking on markers that are refinerys or retails or other asset types
    google.maps.event.addListener(marker, 'click', function() {
      if(this.assettype=='{!refineryTypeId}'){
        refineryname=this.html;
        var refineryPathName;
        lats = [];
        longs = [];
        details = [];
        assettypes = [];
        assetids = [];
        assestnames = [];
        tanknos = [];
        substances = [];
        
        // Reset geojson object
        geoJsonNames.resourceName = [];
        geoJsonNames.jsonName = [];
        // Reset transport layer object
        TransportLayerobj.geoJsonName = [];
        TransportLayerobj.resourceName = [];
        TransportLayerobj.name = [];
        TransportLayerobj.geoType = [];
        var refineryassetUnits=assetUnitsMap[this.assetId];

        for(var a=0;a<refineryassetUnits.lats.length;a++){
          lats.push(refineryassetUnits.lats[a]);
          longs.push(refineryassetUnits.longs[a]);
          details.push(refineryassetUnits.details[a]);
          assettypes.push(refineryassetUnits.assettypes[a]);
          assetids.push(refineryassetUnits.assetids[a]);
          assestnames.push(refineryassetUnits.names[a]);
          tanknos.push(refineryassetUnits.tanknos[a]);
          substances.push(refineryassetUnits.substances[a]);
        }
        mapType = google.maps.MapTypeId.HYBRID;
        refineryPathName=refineryassetUnits.parentname[0];
        refineryPathName=refineryPathName.replace(/ /g,"_");

        // Uncheck the boxes and hide the div
        document.getElementById('myPage:formid:pbid:pbsid:pipeline').checked=false;
        document.getElementById('myPage:formid:pbid:pbsid:RetailSite').checked=false;
        document.getElementById('myPage:formid:pbid:pbsid:transportlayer').checked=false;
        Pipelineobj.flag=false;
        Retailobj.flag=false;
        TransportLayerobj.flag=false;

        // Load the tank 
        loadTankPolygon(refineryPathName);
        window.location.href ='{!basePathSFDC}/apex/HCVC_MapPage?id='+this.assetId+'&sfdc.tabName={!tbcolor}';
        rerenderhistoryoverview(this.assetId);
      } else if(this.assettype=='Retail') {
        window.location.href ='{!basePathSFDC}/'+this.assetId;
      } else {
        window.location.href ='{!basePathSFDC}/apex/HCVC_AssetDetails?id='+this.assetId+'&assettype='+this.assettype+'&aflag=false';
      }
    });

    // Add marker listeners for mouseover and mouse out
    google.maps.event.addListener(marker, 'mouseover', function() {
      infowindow.setContent(this.html);
      infowindow.open(myMap,this);
    });

    google.maps.event.addListener(marker, 'mouseout', function() {
      infowindow.close();
    });

    google.maps.event.addListener(tankpolygon, 'mouseover', function() {
      infopolygon.setContent('<div class="noscrollbar">'+"Prince George Tank Farm"+'</div>');
      infopolygon.open(myMap,infopolygon.setPosition(new google.maps.LatLng(53.928683, -122.701464)));
    });

    google.maps.event.addListener(rackspolygon, 'mouseover', function() {
      infopolygonrack.setContent('<div class="noscrollbar">'+"Prince George Rack"+'</div>');
      infopolygonrack.open(myMap,infopolygonrack.setPosition(new google.maps.LatLng(53.927175, -122.694465)));
    });


    google.maps.event.addListener(tankpolygon, 'mouseout', function() {
      infopolygon.close();
    });

    google.maps.event.addListener(rackspolygon, 'mouseout', function() {
      infopolygonrack.close();
    });

    google.maps.event.addListenerOnce(myMap,'tilesloaded', function() {
      myMap.setOptions({maxZoom:21});
      if(assettypes.length>0){
        if((assettypes[0]=='{!refineryTypeId}')||(assettypes[0]=='Retail')){
          myMap.setCenter(new google.maps.LatLng(51.513156, -104.866525));
        }
      }
      rerenderAssetrecordpb(assetids[0],assettypes[0]);
    });
  } // End for loop
} // End function initialize

// Javascript method to load the lat,long for the Tank Polygon using Refinery path
// This loads the polygon on the map for the refinery tanks
function loadTankPolygon(refineryPathName)
{
  // Load the polygon value for the tank
  if(tankcoordinates[refineryPathName]!=null){
    tankCoordinates = [];
    for(var i=0;i<tankcoordinates[refineryPathName].lats.length;i++){
      tankCoordinates.push(new google.maps.LatLng(tankcoordinates[refineryPathName].lats[i], tankcoordinates[refineryPathName].longs[i]));
    }
  }
  // Load the polygon value for the racks
  if(rackscoordinates[refineryPathName]!=null){
    racksCoordinates = [];
    for(var i=0;i<rackscoordinates[refineryPathName].lats.length;i++){
      racksCoordinates.push(new google.maps.LatLng(rackscoordinates[refineryPathName].lats[i], rackscoordinates[refineryPathName].longs[i]));
    }
  }
  // Re initialize 
  initialize();
}

// Refinery Checkbox code
function checkStatusRefinery(checkvalue){
  var statusrefinery=checkvalue.checked;
  Refineryobj.flag=statusrefinery;

  loadAllCheckboxes();
}

// This resets the status when we go back to the map
function BackToMapStatus(){
  lats = [];
  longs = [];
  details = [];
  assettypes = [];
  assetids = [];
  assestnames = [];
  // Reset geojson object
  geoJsonNames.resourceName = [];
  geoJsonNames.jsonName = [];

  if(Refineryobj.flag==true){
    mapType = google.maps.MapTypeId.ROADMAP;
    for(var j=0;j<Refineryobj.lats.length;j++){
      lats.push(Refineryobj.lats[j]);
      longs.push(Refineryobj.longs[j]);
      details.push(Refineryobj.details[j]);
      assettypes.push(Refineryobj.assettypes[j]);
      assetids.push(Refineryobj.assetids[j]);
      assestnames.push(Refineryobj.assestnames[j]);
    }
  }

  if(Pipelineobj.flag==true){
    mapType = google.maps.MapTypeId.ROADMAP;

    for(var k=0;k<Pipelineobj.geoJsonName.length;k++){
      geoJsonNames.resourceName.push(Pipelineobj.resourceName[k]);
      geoJsonNames.jsonName.push(Pipelineobj.geoJsonName[k]);
    }
  }

  if(Retailobj.flag==true){
    mapType = google.maps.MapTypeId.ROADMAP;

    for(var j=0;j<Retailobj.lats.length;j++){
      lats.push(Retailobj.lats[j]);
      longs.push(Retailobj.longs[j]);
      details.push(Retailobj.details[j]);
      assettypes.push('Retail');
      assetids.push(Retailobj.assetids[j]);
      assestnames.push(Retailobj.assestnames[j]);
    }
  }
  initialize();
}

// Pipeline Checkbox code
function checkStatusPipeline(checkvalue){
  var statuspipeline=checkvalue.checked;
  Pipelineobj.flag=statuspipeline;
  loadAllCheckboxes();
}

// Retail Checkbox code
function checkStatusRetail(checkvalue){
  var statusretail=checkvalue.checked;
  Retailobj.flag=statusretail;
  loadAllCheckboxes();
}

// Transport layer check
function checkStatustransportlayer(checkvalue){
  var statustransport=checkvalue.checked;
  TransportLayerobj.flag=statustransport;
  loadAllCheckboxes();
}

function loadAllCheckboxes(){
  lats = [];
  longs = [];
  details = [];
  assettypes = [];
  assetids = [];
  assestnames = [];
  // Reset geojson object
  geoJsonNames.resourceName = [];
  geoJsonNames.jsonName = [];

  if(Refineryobj.flag==true){
    mapType = google.maps.MapTypeId.ROADMAP;

    for(var j=0;j<Refineryobj.lats.length;j++){
      lats.push(Refineryobj.lats[j]);
      longs.push(Refineryobj.longs[j]);
      details.push(Refineryobj.details[j]);
      assettypes.push(Refineryobj.assettypes[j]);
      assetids.push(Refineryobj.assetids[j]);
      assestnames.push(Refineryobj.assestnames[j]);
    }
  }

  if(Pipelineobj.flag==true){
    mapType = google.maps.MapTypeId.ROADMAP;

    for(var k=0;k<Pipelineobj.geoJsonName.length;k++){
      geoJsonNames.resourceName.push(Pipelineobj.resourceName[k]);
      geoJsonNames.jsonName.push(Pipelineobj.geoJsonName[k]);
    }
  }

  if(Retailobj.flag==true){
    mapType = google.maps.MapTypeId.ROADMAP;

    for(var j=0;j<Retailobj.lats.length;j++){
      lats.push(Retailobj.lats[j]);
      longs.push(Retailobj.longs[j]);
      details.push(Retailobj.details[j]);
      assettypes.push('Retail');
      assetids.push(Retailobj.assetids[j]);
      assestnames.push(Retailobj.assestnames[j]);
    }
  }

  renderTopLevelDataDiv();
  initialize();
}

// Grab the ID from the URL if it is there
function getQueryVariable(variable)
{
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == variable){return pair[1];}
       }
       return(false);
}
// Load the process flow map by redirecting to it
function loadProcessFlowMap(){
  var refineryId = getQueryVariable("id");
  if(refineryId != false) {
    window.location.href ='{!basePathSFDC}/apex/HCVC_ProcessFlowMap?refineryId='+refineryId+'&isRefinery='+Refineryobj.flag+'&isPipeline='+Pipelineobj.flag+'&isRetail='+Retailobj.flag+'&isTransport='+TransportLayerobj.flag;
  } else {
    window.location.href ='{!basePathSFDC}/apex/HCVC_ProcessFlowMap?&isRefinery='+Refineryobj.flag+'&isPipeline='+Pipelineobj.flag+'&isRetail='+Retailobj.flag+'&isTransport='+TransportLayerobj.flag;
  }
}

// Set the assets to a refinery
function setAssetToRefinery(){
  lats = [];
  longs = [];
  details = [];
  assettypes = [];
  assetids = [];
  assestnames = [];

  lats.push(refineryLat);
  longs.push(refineryLong);
  assettypes.push(refineryType);
  details.push(refineryDeatils);
  assetids.push(refineryId);
  assestnames.push(refineryname);

  initialize();
}

// Calls the listener for a load event to call the preSetup method
google.maps.event.addDomListener(window, 'load',preSetup);
</script>

<script type="text/javascript">
$(document).ready(function() {
  var $targets = $('.target');
  $('.links .sublinks').click(function () {
      var $target = $($(this).data('target')).show();
      $targets.not($target).hide();
  });
});

// Main ID
var mainCheckboxId = 'myPage:formid:pbid:pbsid';
// Define the checkbox IDs
var refineryCheckBox = 'myPage:formid:pbid:pbsid:Refinery';
var pipelineCheckBox = 'myPage:formid:pbid:pbsid:pipeline';
var retailSiteCheckBox = 'myPage:formid:pbid:pbsid:RetailSite';
var transportlayerCheckBox = 'myPage:formid:pbid:pbsid:transportlayer';

// Define other element IDs
var mapCanvas = 'map_canvas';
var historyref = 'historyref';
var retailnetworkref = 'retailnetworkref';
var overviewref = 'overviewref';
var pbSubsection = 'pbSubsection';
var topOverviewHistory = 'topoverviewhistoryId';


// This disables the sections for map canvas and other parts of the page
function disableSection(){
  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'none';

  // Checkboxes inside the Filters set to be disabled
  document.getElementById(refineryCheckBox).disabled = true;
  document.getElementById(pipelineCheckBox).disabled = true;
  document.getElementById(retailSiteCheckBox).disabled = true;
  document.getElementById(transportlayerCheckBox).disabled = true;

  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'none';

  var hisref = document.getElementById(historyref);
  hisref.style.display = 'block';
}

// This reenables the sections disabled in the disable section call
function enableSection(){
  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'block';

  var hisref = document.getElementById(historyref);
  hisref.style.display = 'none';

  var rnref = document.getElementById(retailnetworkref);
  rnref.style.display = 'none';

  var hisref = document.getElementById(overviewref);
  hisref.style.display = 'none';

  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'none';

  // Checkboxes inside the Filters set to be enabled
  document.getElementById(refineryCheckBox).disabled = false;
  document.getElementById(pipelineCheckBox).disabled = false;
  document.getElementById(retailSiteCheckBox).disabled = false;
  document.getElementById(transportlayerCheckBox).disabled = false;
}

// This enables the history section 
function enableHistory(){
  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'none';

  var hisref = document.getElementById(historyref);
  hisref.style.display = 'block';

  var rnref = document.getElementById(retailnetworkref);
  rnref.style.display = 'none';

  var hisref = document.getElementById(overviewref);
  hisref.style.display = 'none';

  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'none';

  // Checkboxes inside the Filters set to be disabled
  document.getElementById(refineryCheckBox).disabled = true;
  document.getElementById(pipelineCheckBox).disabled = true;
  document.getElementById(retailSiteCheckBox).disabled = true;
  document.getElementById(transportlayerCheckBox).disabled = true;
}

// Enable the overview section
function enableOverview(){
  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'none';

  var hisref = document.getElementById(overviewref);
  hisref.style.display = 'block';

  var rnref = document.getElementById(retailnetworkref);
  rnref.style.display = 'none';

  var hisref = document.getElementById(historyref);
  hisref.style.display = 'none';

  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'none';

  // Checkboxes inside the Filters and set to be disabled
  document.getElementById(refineryCheckBox).disabled = true;
  document.getElementById(pipelineCheckBox).disabled = true;
  document.getElementById(retailSiteCheckBox).disabled = true;
  document.getElementById(transportlayerCheckBox).disabled =true;
}

// Enables the retail netwrok
function enableRetailNetwork(){
  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'none';

  var rnref = document.getElementById(retailnetworkref);
  rnref.style.display = 'block';

  var hisref = document.getElementById(overviewref);
  hisref.style.display = 'none';

  var hisref = document.getElementById(historyref);
  hisref.style.display = 'none';

  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'none';

  // Checkboxes inside the Filters to be disabled
  document.getElementById(refineryCheckBox).disabled = true;
  document.getElementById(pipelineCheckBox).disabled = true;
  document.getElementById(retailSiteCheckBox).disabled = true;
  document.getElementById(transportlayerCheckBox).disabled = true;
}


// This shows a div based on an asset ID
function showDiv(assetId){
  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'none';
  var topOverview = document.getElementById(topOverviewHistory);
  topOverview.style.display = 'block';

  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'none';

  // Checkboxes inside the Filters to be disabled 
  document.getElementById(refineryCheckBox).disabled = true;
  document.getElementById(pipelineCheckBox).disabled = true;
  document.getElementById(retailSiteCheckBox).disabled = true;
  document.getElementById(transportlayerCheckBox).disabled = true;

  // Call the setTopHistoryOverview in controller for apex after calling actin function
  renderTopLevelDiv(assetId);
}

// Hides a div based on asset ID
function hideDiv(){
  var myMap = document.getElementById(mapCanvas);
  myMap.style.display = 'block';
  var topOverview = document.getElementById(topOverviewHistory);
  topOverview.style.display = 'none';

  var search = document.getElementById(mainCheckboxId).getElementsByClassName(pbSubsection)[0];
  search.style.display = 'block';

  // Checkboxes inside the Filters
  document.getElementById(refineryCheckBox).disabled = false;
  document.getElementById(pipelineCheckBox).disabled = false;
  document.getElementById(retailSiteCheckBox).disabled = false;
  document.getElementById(transportlayerCheckBox).disabled = false;
}
</script>
</head>

<body>
  <apex:form id="formid">
  <div id="maincontent">
    <table>
      <tr>
        <td width="250px" valign="top" >
          <div style="width:250px">
            <apex:pageBlock id="pbid">
                <apex:pageBlockSection title="Display Filter" id="pbsid" columns="2">
                  <label for="Refinery">Refineries</label><apex:inputCheckbox id="Refinery"  onclick="checkStatusRefinery(this)"  styleClass="chkbox" selected="true" />
                  <label for="pipeline">Crude Pipelines</label><apex:inputCheckbox id="pipeline"  onclick="checkStatusPipeline(this)"  selected="false"  />
                  <label for="RetailSite">Retail Sites</label><apex:inputCheckbox id="RetailSite" onclick="checkStatusRetail(this)" selected="false" />
                  <label for="transportlayer">Railways</label><apex:inputCheckbox id="transportlayer" onclick="checkStatustransportlayer(this)" selected="false" />
                  <label for="Competitors">Competitors</label><apex:inputCheckbox id="Competitors"  disabled="true"/>
                </apex:pageBlockSection>
            </apex:pageBlock>

            <!-- Overview section for refinery -->
            <div class="sublinks">
              <apex:outputPanel id="overviewsectionId">
                <apex:pageBlock rendered="{!isTopOverview=true}" >
                  <apex:pageBlockSection title="Overview" id="topLevelhoId" columns="1">
                   <apex:pageBlockTable value="{!topLevelOverviews}" var="tlo" headerClass="hidden">
                     <apex:column >
                      <u><a href='' onClick="showDiv('{!tlo.Id}')" >{!tlo.Name}</a></u>
                     </apex:column>
                   </apex:pageBlocktable>
                 </apex:pageBlockSection>
                </apex:pageBlock>

                <apex:outputPanel id="refineryoverviewsectionId" style="background-color: white;">
                  <apex:pageBlock rendered="{!isTopOverview=false}" >
                    <apex:pageBlockSection title="Overview" id="refineryhistoryoverviewid" columns="1" >
                     <table  class="table" border="1" style="border-collapse: collapse;border: 1px solid black;" >
                       <tr class="ex3" bgcolor="#FFFFFF" ><td style="border: 1px solid #E0E3E5;padding: 4px 2px 4px 5px;"> <a class="sublinks" data-target=".history"  href='' onclick="enableHistory()" >  {!assetHistory}  </a></td> </tr>
                       <tr class="ex3" bgcolor="#FFFFFF"><td style="border: 1px solid #E0E3E5;padding: 4px 2px 4px 5px;"><a class="sublinks" data-target=".overview" href='' onclick="enableOverview()" > {!assetOverview}  </a></td> </tr>
                       <tr class="ex3" bgcolor="#FFFFFF"><td style="border: 1px solid #E0E3E5;padding: 4px 2px 4px 5px;white-space: nowrap"><a  class="sublinks" data-target=".retailnetwork" href='' onclick="enableRetailNetwork()" > {!assetRetailNetwork}</a></td></tr>
                     </table>
                    </apex:pageBlockSection>
                  </apex:pageBlock>
                </apex:outputPanel>
              </apex:outputPanel>
            </div>
            <!-- End overview section for refinery -->

            <!-- Other information block for process flow map -->
            <apex:pageBlock >
              <apex:pageBlockSection title="Process Flow Map" columns="1" >
                <table class="list" border="1" style="border-collapse: collapse;border: 1px solid black;" >
                  <tr class="ex3" bgcolor="#FFFFFF" >
                    <td style="border: 1px solid #E0E3E5;padding: 4px 2px 4px 5px;"><a href="" onclick="loadProcessFlowMap()" class="hn">Process Flow Map</a></td> 
                  </tr>
                </table>
              </apex:pageBlockSection>
            </apex:pageBlock>

            <apex:pageBlock >
              <apex:pageBlockSection columns="1" id="AssetrecordpbId" title="Assets">
                <apex:pageBlocktable var="asset" value="{!assets}" headerClass="hidden">
                  <apex:column rendered="{!asset.RecordTypeId!=null}">
                    <a href='{!basePathSFDC}/apex/HCVC_AssetDetails?id={!asset.Id}&aflag=false'>{!asset.Name}</a>
                  </apex:column>
                  <apex:column rendered="{!asset.RecordTypeId=null}">
                    <a href='{!basePathSFDC}/apex/HCVC_TankMapPage?id={!asset.Id}'>{!asset.Name}</a>
                  </apex:column>
                </apex:pageBlocktable>
              </apex:pageBlockSection>
            </apex:pageBlock>
          </div>
        </td>

        <td width="100%" valign="top">
          <!-- This div is top level Overview -->
          <div id="topoverviewhistoryId">
            <a href='' onClick="hideDiv()" class="links sublinks"><button type="button" class="custom-button btn-primary-custom">Back to Map</button></a>
            <apex:outputPanel layout="block" style="overflow:auto;height:500px;">
              <apex:pageBlock title="" id="topohId">
                <apex:outputText value="{!topOverviewHistory}" escape="false"  />
              </apex:pageBlock>
            </apex:outputPanel>
          </div>
          <!--End  top level Overview  -->
          <div id="map_canvas"></div>
          <!-- Refinery History/Overivew Starts -->
          <div class="history target " id="historyref">
            <div class="links"> <a class="sublinks" data-target=".map" href='' onclick="enableSection()"><button type="button" class="custom-button btn-primary-custom">Back to Map</button></a></div>

            <apex:outputPanel layout="block"  style="overflow:auto;height:500px;">
              <apex:pageBlock title="" id="refineryhistory">
                <apex:outputText value="{!refineryHistory}" escape="false" />
              </apex:pageBlock>
            </apex:outputPanel>
          </div>

          <div class="overview target " id="overviewref">
            <div class="links"><a class="sublinks" data-target=".map" href='' onclick="enableSection()"><button type="button" class="custom-button btn-primary-custom">Back to Map</button></a></div>
            <apex:outputPanel layout="block"  style="overflow:auto;height:500px">
              <apex:pageBlock title="" id="refineryoverview">
                <apex:outputText value="{!refineryOverview}" escape="false" />
              </apex:pageBlock>
            </apex:outputPanel>
          </div>

          <div class="retailnetwork target " id="retailnetworkref">
            <div class="links"><a class="sublinks" data-target=".map" href='' onclick="enableSection()"><button type="button" class="custom-button btn-primary-custom">Back to Map</button></a></div>
            <apex:outputPanel layout="block"  style="overflow:auto;height:500px">
              <apex:pageBlock title="" id="refineryretailnetwork">
                <apex:outputText value="{!refineryRetailnetwork}" escape="false" />
              </apex:pageBlock>
            </apex:outputPanel>
          </div>
          <!-- Refinery History/Overview Ends -->
        </td>
      </tr>
    </table>

    <!-- Define action functions to call javascript in APEX -->
    <apex:actionFunction action="{!loadPlacemarker}" name="rerenderAssetrecordpb" reRender="AssetrecordpbId" status="loadStatus" >
      <apex:param name="aname"  value="" assignTo="{!assetid}" />
      <apex:param name="bname"  value="" assignTo="{!assettype}"/>
    </apex:actionFunction>

    <apex:actionFunction action="{!setRefineryHistoryOverview}" name="rerenderhistoryoverview" reRender="refineryhistory,refineryoverview,overviewsectionId,refineryhistoryoverviewid,refineryretailnetwork" status="loadStatus" >
      <apex:param name="cname"  value="" assignTo="{!assetidHistory}" />
    </apex:actionFunction>

    <apex:actionFunction action="{!setTopHistoryOverview}" name="renderTopLevelDiv" reRender="topohId" status="loadStatus" >
      <apex:param name="dname"  value="" assignTo="{!assetthoid}" />
    </apex:actionFunction>

    <apex:actionFunction action="{!setTopHistoryOverviewFlag}" name="renderTopLevelDataDiv" reRender="overviewsectionId,refineryhistoryoverviewid" status="loadStatus" >
    </apex:actionFunction>
  </div>
  <!-- END MAIN DIV WRAPPER -->
  </apex:form>
</body>
</html>
</apex:page>